module Main where

import Account
import Corba
import IOExts
import System

--------------------------------
--          MAIN
--------------------------------

main = do
	   args <- getArgs
	   (orb, _) <- corba_ORB_init ("xxx" : args)
	   corba_Server_run orb () serverInit
	   where
		serverInit ps = do
			ls <- newIORef 0
			(obj, ps) <- c_Account__servant_open ps (servant ls)
			return ps

		servant ls = C_Account__servant {
			impl_c_Account_deposit 	= my_deposit ls,
			impl_c_Account_withdraw = my_withdraw ls,
			impl_c_Account_balance 	= my_balance ls
		}			

		my_deposit ls ps what
			= do
				putStrLn "my_deposit"
				balance <- readIORef ls
				writeIORef ls (balance + what)
				return (ps, Result ())

		my_withdraw ls ps what
			= do
				putStrLn "my_withdraw"
				balance <- readIORef ls
				writeIORef ls (balance - what)
				return (ps, Result ())

		my_balance ls ps
			= do
				putStrLn "my_balance"
				balance <- readIORef ls
				return (ps, Result balance)

-- Local Variables:
-- tab-width: 4
-- End:




