module Main where

import Corba
import CorbaWrappers
import Test
import IORef

import Test

--------------------------------
--          MAIN
--------------------------------


main = do
--	(orb, _) <- corba_ORB_init ["foo", "-ORBDebugLevel", "0", "-ORBIIOPAddr", "inet:localhost:4242"]
	(orb, _) <- corba_ORB_init ["foo", "-OAport", "9999"]
	corba_Server_run orb () serverInit
	where
		serverInit ps = do
			ls <- newIORef 0
			(obj, ps) <- c_Useless__servant_open ps (servant ls)
			writeIORToFile (corba_Server_get_orb ps) obj "server.ior"
			return ps

		servant ls = C_Useless__servant {
			impl_c_Useless_echo 		= my_echo ls,
			impl_c_Useless_deposit	= my_deposit ls,
			impl_c_Useless_withdraw	= my_withdraw ls,
			impl_c_Useless_balance	= my_balance ls,
			impl_c_Useless_balance2	= my_balance2 ls,
			impl_c_Useless_echo_any	= my_echo ls,
			impl_c_Useless_echo_tc	= my_echo ls,
			impl_c_Useless_self		= my_self ls,
			impl_c_Useless_echo_objref= my_echo ls,
			impl_c_Useless_echo_struct= my_echo ls,
			impl_c_Useless_echo_recursive = my_echo ls,
			impl_c_Useless_echo_seq	= my_echo ls,
			impl_c_Useless_echo_union	= my_echo ls,
			impl_c_Useless_echo_implicit_union = my_echo ls,
			impl_c_Useless_echo_enum	= my_echo ls,
			impl_c_Useless_echo_array	= my_echo ls,
			impl_c_Useless_raise_exception = my_raise_exception ls,
			impl_c_Useless_test_args	= my_test_args ls,
			impl_c_Useless_test_exit	= my_test_exit ls,
			impl_c_Useless__get_an_attribute	= my_get_an_attribute ls,
			impl_c_Useless__set_an_attribute	= my_set_an_attribute ls
		}			

		my_deposit ls ps what
			= do
				putStrLn "my_deposit"
				balance <- readIORef ls
				writeIORef ls (balance + what)
				return (ps, Result ())

		my_withdraw ls ps what
			= do
				putStrLn "my_withdraw"
				balance <- readIORef ls
				writeIORef ls (balance - what)
				return (ps, Result ())

		my_balance ls ps
			= do
				putStrLn "my_balance"
				balance <- readIORef ls
				return (ps, Result balance)

		my_balance2 ls ps
			= do
				putStrLn "my_balance2"
				balance <- readIORef ls
				return (ps, Result ((), balance))

		my_echo ls ps what
			= return (ps, Result what)

		my_echo_any ls ps what
			= return (ps, Result what)

		my_echo_tc ls ps what
			= return (ps, Result what)

		my_self ls ps
			= do
				(Just this) <- c_Useless__narrow (corba_Server_get_current ps)
				return (ps, Result this)

		my_raise_exception ls ps
			= return (ps, Exception ex)
			where
				ex = UserException c_Useless_Useless_Exception__repoid (c_Useless_Useless_Exception__encode (C_Useless_Useless_Exception 1 2))

		my_test_args ls ps arg1 arg3
			= return (ps, Result (arg3, arg1, arg3 + 1))

		my_test_exit ls ps
			= return (corba_Server_exit ps, Result ())

		my_get_an_attribute ls ps
			= return (ps, Result "foo")

		my_set_an_attribute ls ps value
			= return (ps, Result ())

-- DSI based servant
{-
main = do
	(orb, _) <- corba_ORB_init ["foo", "-ORBIIOPAddr", "inet:localhost:4242"]
	corba_Server_run orb () serverInit
	where
		serverInit ps = do
			ls <- newMVar 0
			(_, ps) <- corba_Server_add_servant ps "IDL:Useless:1.0" (servant ls)
			return ps

		servant ls = CORBA_Servant_Wrapper (servant_dispatch ls)

		servant_dispatch ls ps req = do
			corba_ServerRequest_set_arg_types req  []
--				(InArgTemplate "what" corba_Short__tc) ] 
			v <- takeMVar ls
			putStrLn (show v)
			putMVar ls (v + 1)
			op <- corba_ServerRequest_operation req
			putStrLn op
			return ps
-}



-- Local Variables:
-- tab-width: 4
-- End:




